<?php
/**
 * Magento
 *
 * NOTICE OF LICENSE
 *
 * This source file is subject to the Open Software License (OSL 3.0)
 * that is bundled with this package in the file LICENSE.txt.
 * It is also available through the world-wide-web at this URL:
 * http://opensource.org/licenses/osl-3.0.php
 * If you did not receive a copy of the license and are unable to
 * obtain it through the world-wide-web, please send an email
 * to license@magento.com so we can send you a copy immediately.
 *
 * DISCLAIMER
 *
 * Do not edit or add to this file if you wish to upgrade Magento to newer
 * versions in the future. If you wish to customize Magento for your
 * needs please refer to http://www.magento.com for more information.
 *
 * @category    Mage
 * @package     Mage_Adminhtml
 * @copyright  Copyright (c) 2006-2017 X.commerce, Inc. and affiliates (http://www.magento.com)
 * @license    http://opensource.org/licenses/osl-3.0.php  Open Software License (OSL 3.0)
 */

/**
 * Shipment view form
 *
 * @category   Mage
 * @package    Mage_Adminhtml
 * @author      Magento Core Team <core@magentocommerce.com>
 */
class Joovii_Sendleapi_Block_Sales_Order_Shipment_View_Form extends Mage_Adminhtml_Block_Sales_Order_Shipment_View_Form
{
    
	
    public function canCreateShippingLabel()
	{
		return true;		
		
	}
	public function getCreateLabelButton()
    {
        //$data['shipment_id'] = $this->getShipment()->getId();
		
		$orderId = $this->getShipment()->getOrder()->getId();
		$orderObj = Mage::getModel('sales/order')->load($orderId);
		
		
		$psoArr = explode(",",Mage::getStoreConfig('carriers/sendle/processassendleorder'));
		$postToSendle = 0;			
		if(in_array("flat_rate", $psoArr) && $orderObj->getShippingMethod()=="flatrate_flatrate"){
			$postToSendle = 1;	
		}
		if(in_array("free_rate", $psoArr) && $orderObj->getShippingMethod()=="freeshipping_freeshipping"){
			$postToSendle = 1;	
		}
		if(trim($orderObj->getShippingMethod()) == 'sendle_sendleapi' || $postToSendle ==1){
			
			if (Mage::getStoreConfig('carriers/sendle/enablelog')) {
				Mage::log("-------getCreateLabelButton yes ---------".$orderObj->getShippingMethod() , null, "sendleapi1001.log");
			}
			
		}else{
			if (Mage::getStoreConfig('carriers/sendle/enablelog')) {
				Mage::log("-------getCreateLabelButton no ---------".$orderObj->getShippingMethod() , null, "sendleapi1001.log");
			}
			return false;	
		}
			
		/*if(trim($orderObj->getShippingMethod()) != 'sendle_sendleapi'){
			return false;	
		}*/
        // $url = $this->getUrl('*/sales_order_shipment/createLabel', $data);
		$url = $this->getUrl('*/Sendleapi/downloadLabel', array('orderid' =>$orderId) );
        return $this->getLayout()
            ->createBlock('adminhtml/widget_button')
            ->setData(array(
                'label'   => Mage::helper('sales')->__('Download Shipping Label'),
                'onclick' => 'window.open(\'' . $url . '\',\'_blank\')'				
            ))
            ->toHtml();
    }

    

   	
	
}
