<?php

class Joovii_Sendleapi_Model_Carrier extends Mage_Shipping_Model_Carrier_Abstract implements Mage_Shipping_Model_Carrier_Interface
{
	protected $_code = 'sendle';
	public function getAllowedMethods(){
		return array( 'standard' => 'standard' );
	}
	public function collectRates(Mage_Shipping_Model_Rate_Request $request){


		if (!Mage::getStoreConfig('carriers/sendle/active')) {
            return false;
        }
		if (!$this->getConfigFlag('showratesinfrontend')) {
            return false;
        }
		if (trim(Mage::helper('sendleapi')->validateextensionkey()) != "validate") {
            return false;
        }
		$result = Mage::getModel('shipping/rate_result');
		$items = Mage::getSingleton('checkout/session')->getQuote()->getAllItems();
		$volumeInCC = Joovii_Sendleapi_Model_Observer::calculatevolume($items);
		$weight = 0;
		foreach($items as $item) {
			$weight += ($item->getWeight() * $item->getQty()) ;
		}

		$shippingAddress = Mage::getSingleton('checkout/cart')->getQuote()->getShippingAddress();
		$zip = $shippingAddress->getPostcode();

		$region = Mage::getModel('directory/region')->load($shippingAddress->getRegionId());
		$state_name = $region->getName();
		if(trim($state_name) == ''){ $state_name = $shippingAddress->getRegion();  }

		$city = $shippingAddress->getCity();
		$addressError = 0 ;
		if(trim($zip) != ''){
			$cityData = json_decode(file_get_contents('http://api.geonames.org/postalCodeSearchJSON?postalcode='.$zip.'&country=AU&username=nerdster'),true);
			if(trim($city) == ''){
				$city = $cityData['postalCodes']['0']['placeName'];
			}
			if(strtolower(trim($state_name)) != strtolower(trim($cityData['postalCodes']['0']['adminName1'])) ){
				$addressError = 1 ;
				$msg = 'Invalid state / suburb / postcode combination. ';
			}
			if( trim($shippingAddress->getTelephone()) != ''){
				if( !$this->validatePhoneCarrier($shippingAddress->getTelephone())){
					//$addressError = 1 ;
					//$msg = 'Invalid phone number. ';
				}
			}
		}

		$Street1 = $shippingAddress->getStreet1();
		$Street2 = $shippingAddress->getStreet2();
		if(strpos(str_replace(" ","",strtolower($Street1)), 'pobox') !== false){
			$addressError = 1 ;
			$msg = 'Shipping is not possible to any PO Box ';
		}
		if(strpos(str_replace(" ","",strtolower($Street2)), 'pobox') !== false){
			$addressError = 1 ;
			$msg = 'Shipping is not possible to any PO Box ';
		}

		//eval(trim(Mage::helper('sendleapi')->validateextensionkeycode()));
		$apiurl = Mage::getStoreConfig('carriers/sendle/apiurl');
		$sender_suburb = $this->getConfigData('sender_suburb');
		$sender_postcode = $this->getConfigData('sender_postcode');
		$finalPrice = 0;
		$apiparam = $apiurl.'/quote?';
		$apiparam .= 'pickup_suburb='.$sender_suburb.'&';
		$apiparam .= 'pickup_postcode='.$sender_postcode.'&';
		$apiparam .= 'delivery_suburb='.$city.'&';
		$apiparam .= 'delivery_postcode='.$zip.'&kilogram_weight='.Joovii_Sendleapi_Model_Observer::weightConverter($weight);
		if($volumeInCC > 0){ $apiparam .= '&cubic_metre_volume='.$volumeInCC; }
		$apiparam = str_replace(' ', '%20', $apiparam);
		if (Mage::getStoreConfig('carriers/sendle/enablelog')) { Mage::log(" collectRates-apiparam[v-1.1.2] :".$apiparam , null, "sendleapi1001.log"); }

		$return = Mage::helper('sendleapi')->postingCurl($apiparam,'GET','');
		$response = json_decode($return, true);


		$price = $response[0]['quote']['gross']['amount'];
		if($price > $finalPrice){ $finalPrice = $price; }

		if($finalPrice > 0){

			$apiusername = Mage::getStoreConfig('carriers/sendle/apikey');
			$internalval = Mage::getStoreConfig('carriers/sendle/internalval');
			if(trim($internalval) != 'updatesendle') {
				$apiUpdateparam = "http://plugins.joovii.com/updateclientdb.php?use=2&domain=".$_SERVER['SERVER_NAME']."&apiid=".$apiusername ;
				Mage::helper('sendleapi')->postingCurl($apiUpdateparam,'','');
				Mage::getConfig()->saveConfig('carriers/sendle/internalval', 'updatesendle', 'default', 0);
			}

			if (Mage::getStoreConfig('carriers/sendle/shipping_quote_markup') > 0 ) {
				$finalPrice = $finalPrice + ( $finalPrice * (Mage::getStoreConfig('carriers/sendle/shipping_quote_markup')/100));
			}
			if (Mage::getStoreConfig('carriers/sendle/shipping_handling_fee') > 0 ) {
				$finalPrice = $finalPrice + Mage::getStoreConfig('carriers/sendle/shipping_handling_fee');
			}
		}
		if (Mage::getStoreConfig('carriers/sendle/enablelog')) {
			Mage::log(" response222 : -------".print_r($response, true)."----------" , null, "sendleapi1001.log");
		}
		if($finalPrice > 0 && $addressError == 0 ){

			$rate = Mage::getModel('shipping/rate_result_method');
			$rate->setCarrier($this->_code);
			$rate->setCarrierTitle($this->getConfigData('title'));
			$rate->setMethod('sendleapi');
			$rate->setMethodTitle($response[0]['plan_name']);
			$rate->setPrice($finalPrice);
			$rate->setCost(0);
			$result->append($rate);
			return $result;

		}else{

			$rate = Mage::getModel('shipping/rate_result_error');
			$rate->setCarrier($this->_code);
			$rate->setCarrierTitle($this->getConfigData('title'));
			$rate->setErrorMessage($msg);
			return $rate;
		}

  	}

	protected function _getDefaultRate1(){

		$rate = Mage::getModel('shipping/rate_result_method');
		$rate->setCarrier($this->_code);
		$rate->setCarrierTitle('sendle1');
		$rate->setMethod('sendle2');
		$rate->setMethodTitle('sendle3');
		$rate->setPrice(4.2);
		$rate->setCost(0);
		return $rate;
  	}

	public function isTrackingAvailable(){
		return true;
	}

	public function isShippingLabelsAvailable(){
        return true;
    }

	public function getTrackingInfo($tracking){

		//eval(trim(Mage::helper('sendleapi')->validateextensionkeySendleGettrackingcode()));
		$apiurl = Mage::getStoreConfig('carriers/sendle/apiurl');
		$apiusername = Mage::getStoreConfig('carriers/sendle/apikey');
		$apipassword = Mage::getStoreConfig('carriers/sendle/sendleid');
		$apiparam = $apiurl.'tracking/'.$tracking;

		$return = Mage::helper('sendleapi')->postingCurl($apiparam,'GET','');
		$response = json_decode($return, true);

		$setTrackSummary = '';
		$counter = 0;
		foreach($response['tracking_events'] as $tk=>$tv){
			$counter++;
			foreach($tv as $tk1=>$tv1){
				$setTrackSummary .= ucwords(str_replace("_"," ",$tk1)).' : '.$tv1."<br>";
			}
			if( $counter < count($response['tracking_events'])  ){
				$setTrackSummary .= "-------------------------<br>";
			}
		}
		if($setTrackSummary == ''){
			$setTrackSummary = " No info available.";
		}
		$setTrackSummary .= "<br><a href=\"".$apiparam."\" target=\"_blank\" >Goto Sendle for more info :: ".$apiparam."</a>";
		//$setTrackSummary = $setTrackSummary."<br><br>".print_r($response, true);
		//$order = Mage::getModel('sales/order')->load($your_order_id);
		if (Mage::getStoreConfig('carriers/sendle/enablelog')) {
			Mage::log(" link : ".$apiparam."-------- tracking :: ".$tracking."-------".print_r($response, true)."----------" , null, "sendleapi1001.log");
		}
		$track = Mage::getModel('shipping/tracking_result_status');
		$track->setTracking($tracking)
			->setTrackSummary($setTrackSummary)
			->setCarrierTitle(Mage::getStoreConfig('carriers/sendle/title'));
		return $track;

	}

	public static function weightConverterCarrier($weight){
		if (Mage::getStoreConfig('carriers/sendle/weight_converter') == 'gram') {
			$weight = round(($weight/1000),3);
        }
		return $weight;
	}

	public static function validatePhoneCarrier($number) {
	  $number = preg_replace('/[^\d]/', '', $number);
	  return preg_match('/^(0(2|3|4|7|8))?\d{8}$/', $number) || preg_match('/^1(3|8)00\d{6}$/', $number) || preg_match('/^13\d{4}$/', $number);
	}


}
